#!/usr/local/bin/perl
# add.cgi
# Add or update a server or group from the webmin servers module

require './cluster-software-lib.pl';
&ReadParse();
@servers = &list_servers();

if ($in{'add'}) {
	# Add a single host
	@add = grep { $_->{'id'} eq $in{'server'} } @servers;
	&error_setup($text{'add_err'});
	}
else {
	# Add all from a group
	@add = grep { $_->{'group'} eq $in{'group'} } @servers;
	&error_setup($text{'add_gerr'});
	}

# Get the packages for each host
%sconfig = &foreign_config("software");
foreach $s (@add) {
	local $host = { 'id' => $s->{'id'} };
	&remote_foreign_check($s->{'host'}, "software") ||
		&error(&text('add_echeck', $s->{'host'}));
	&remote_foreign_require($s->{'host'}, "software", "software-lib.pl");
	local $rconfig = &remote_foreign_config($s->{'host'}, "software");
	$rconfig->{'package_system'} eq $sconfig{'package_system'} ||
		&error(&text('add_esystem', $s->{'host'}));
	local $gconfig = &remote_foreign_config($s->{'host'}, undef);
	foreach $g ('os_type', 'os_version',
		    'real_os_type', 'real_os_version') {
		$host->{$g} = $gconfig{$g};
		}
	local $n = &remote_foreign_call($s->{'host'}, "software",
					"list_packages");
	local $packages = &remote_eval($s->{'host'}, "software", "\\%packages");
	for($i=0; $i<$n; $i++) {
		push(@{$host->{'packages'}},
		     { 'name' => $packages->{$i,'name'},
		       'class' => $packages->{$i,'class'},
		       'desc' => $packages->{$i,'desc'} });
		}
	&save_software_host($host);
	}
&remote_finished();
&redirect("");

